function exa4(k);
% Herramienta didactica, Carlos E. Mejia, 2002
% Datos generados por gen1 y grabados en mar1.dat
% columna 1: coordenada x, columna 2: coordenada y
% columna 3: profundidad (z)
% columna 4: transmisividad optica (r)
% columna 5: velocidad (v)
% se simulan mediciones de z, r, v en nodos de una
% cuadricula que cubre un rectangulo cerca de la costa
% todos los numeros en mar1.dat son ficticios
% k parametro de discretizacion
% uso exa4(k)
gen1
load mar1.dat;
% ahora tenemos una nueva variable mar1 que es una matriz 
% con 5 columnas y tantas filas como filas tenga mar1.dat
x=mar1(:,1);y=mar1(:,2);z=mar1(:,3);nr=mar1(:,4);nv=mar1(:,5);  
mx = min(x); Mx = max(x); my = min(y); My = max(y);
[xi,yi]=meshgrid(linspace(mx,Mx,k),linspace(my,My,k));
% se prepara malla 2-D
zi=griddata(x,y,z,xi,yi,'cubic');
% Interpolacion de datos a nueva malla
figure;
subplot(2,1,1);
surface(xi,yi,zi)  % Visualizacion
title(['Organizacion y visualizacion',' k: ',num2str(k)]); 
xlabel('Eje X'); ylabel('Eje Y'); 
shading interp;
subplot(2,1,2);
surf(zi);
xlabel('Eje X'); ylabel('Eje Y'); 
zlabel('Profundidad');colormap(copper)
colorbar('vert');
%print -deps2 .\fig\exa4-1.eps
figure;
subplot(1,2,1)
plot(nr,z,'k');title('Transmisividad ptica');
subplot(1,2,2)
plot(nv,z,'k');title('Velocidad');
print -deps2 .\fig\exa4-2.eps

