function vnew=smith27ci(tfin,n);
% Herramienta didactica, Carlos E. Mejia 2002
% Ejemplo 2-7 de Smith, ec. parabolica 1D
% tfin: tiempo final
% n: numero de subintervalos en [0,1], n>2
% h: tamao de paso en espacio
% k: tamao de paso en tiempo
h=1/n;
k=h^2; % k puede definirse en otras formas si se desea
p=h^2/k;
% x: dominio espacial, xa: dominio espacial ampliado
x=(h:h:1-h)';xa=[0;x;1];
% vold: condicion inicial
vold=4.*x.*(1-x);
vnew=vold;
t=0;
while t<tfin
    va=[0;vnew;0];
    plot(xa,va,'r');
    title('Difusion no lineal');
    xlabel('Espacio')
    hold on;
    	 count=floor(t/k)+1;
    % condiciones de borde son homogeneas
    % diferencias finitas tomadas en ih en espacio y (j+1/2)k en tiempo
    % g: parte conocida en F(v), depende de v en tiempo anterior 
    % fv: parte de F(v) que depende de v en tiempo actual
    % jf: matriz jacobiana de F
    in2=1;it=1;
    while in2>1.e-8 & it<10
    g=zeros(n-1,1);fv=g;jf=zeros(n-1);
g(1)=vold(2)^2-2*(vold(1)^2-p*vold(1));
fv(1)=vnew(2)^2-2*(vnew(1)^2+p*vnew(1))+g(1);
jf(1,1)=-4*vnew(1)-2*p;
jf(1,2)=2*vnew(2);
g(n-1)=-2*(vold(n-1)^2-p*vold(n-1))+vold(n-2)^2;
fv(n-1)=-2*(vnew(n-1)^2+p*vnew(n-1))+vnew(n-2)^2+g(n-1);
jf(n-1,n-2)=2*vnew(n-2);
jf(n-1,n-1)=-4*vnew(n-1)-2*p;
for i=2:n-2
    g(i)=vold(i+1)^2-2*(vold(i)^2-p*vold(i))+vold(i-1)^2;
    fv(i)=vnew(i+1)^2-2*(vnew(i)^2+p*vnew(i))+vnew(i-1)^2+g(i);
    jf(i,i-1)=2*vnew(i-1);
    jf(i,i)=-4*vnew(i)-2*p;
    jf(i,i+1)=2*vnew(i+1);
end
% solucion sistema lineal asociado con metodo de Newton
in=jf\-fv;
in2=norm(in);
% actualizacion de vold y vnew
vnew=vnew+in;it=it+1;
end
t=t+k;vold=vnew;
end
%print -deps2 .\fig\sm27-1.eps