% gen1.m Herramienta didactica, Carlos E. Mejia, 2002 
% genera datos ficticios para procesamiento de informacion
% se piensa en sector rectangular cercano a la costa
% x: coordenada x, y: coordenada y
% z: profundidad, 
% v: velocidad del agua, r: transmisividad optica
fi1=fopen('mar1.dat','w');
% transmisividad optica
A=40;B=80;step=.4;
r=A+step:step:B;lr=length(r);
p=linspace(-8,0,lr); %profundidad, variable z
s=rand(size(r));
nr=2*log(r-A)+0.1;
C=nr(1);D=nr(lr);
c1=(A-B)/(C-D);c2=(B*C-A*D)/(C-D);
nr=c1*nr+c2;
nr=nr+3*round(rand)*s;
% velocidad
v0=40;vf=140;
v=linspace(v0+1,vf,lr);
nv=3*log(v-v0)+2*rand;
cv=nv(1);dv=nv(lr);
d1=(v0-vf)/(cv-dv);d2=(vf*cv-v0*dv)/(cv-dv);
nv=d1*nv+d2;
s=rand(size(r));
nv=nv+6*round(rand)*s;
x=linspace(0,5000,10);y=linspace(0,3000,10);l10=floor(lr/10);
nx=linspace(0,5000,lr);ny=linspace(0,3000,lr);
for j=1:lr-1
	m=mod(j,l10);q=(j-m)/l10;
   % j=l10*q+m
   if mod(j,l10)==0
      nx(j)=x(j-q*l10+1);
   else
      nx(j)=x(j-q*l10);
   end
   ny(j)=q*300;
end
for i=1:lr   
out=[nx(i) ny(i) p(i) nr(i) nv(i)];
fprintf(fi1,'%8.2f %8.2f %8.2f %8.2f %8.2f\n',out);
end
fclose('all');