function out = m4(f_fun,f_prima,s,x0)
% Rutina preparada por Carlos E. Mejia como herramienta didactica
% Escuela de Matematicas, Universidad Nacional de Colombia
% Medellin, COLOMBIA, 2001
% Direccion electronica: cemejias@epm.net.co
% Pagina WEB: 
%
% Uso z = m4('f_fun','f_prima',s,x0);
% Se aproxima el cero s de f_fun por medio de la
% iteracion de punto fijo con funcion de iteracion dada por
% el Metodo de Newton 
% x0 es la primera aproximacion
% El cero s es conocido pero no se utiliza en el proceso
% iterativo. Solo se usa para listar las dos ultimas
% columnas de la tabla de resultados
% La ultima columna ilustra la convergencia cuadratica del metodo
fprintf('Mtodo de Newton y convergencia cuadratica\n\n');
epsi=input('Valor para epsilon: ');
Nuit=input('Valor para nmero maximo de iteraciones: ');
v=feval(f_fun,x0);vp=feval(f_prima,x0);e0=s-x0;
disp('   k       x_k      f(x_k)      e_k       e_k/(e_(k-1))    e_k/(e_(k-1))^2');
out=[0,x0,v,e0];
fprintf('%2.0f %5.4f %4.1e %4.1e\n',out);
for k=1:Nuit
   x1=x0-v/vp;
   v=feval(f_fun,x1);vp=feval(f_prima,x1);
   e1=s-x1;
   out=[k,x1,v,e1,e1/e0,e1/e0^2];
	fprintf('%2.0f %5.4f %4.1e %4.1e %4.1e %4.1e\n',out);
   if (abs(x1-x0)<epsi | abs(v)<epsi)
      break
   end
   x0=x1;e0=e1;
end
   